2023-05-22 12:54:10 +02:00
#!/usr/bin/env bash
# Copyright (c) 2021-2023 tteck
# Author: tteck (tteckster)
# Jon Spriggs (jontheniceguy)
# License: MIT
# https://github.com/tteck/Proxmox/raw/main/LICENSE
# Based on work from https://i12bretro.github.io/tutorials/0405.html
function header_info {
2023-05-23 13:36:27 +02:00
clear
2023-05-22 12:54:10 +02:00
cat <<"EOF"
2023-05-23 13:36:27 +02:00
____ _ __ __
/ __ \_ ___ ___ ____| | / /____/ /_
/ / / / __ \/ _ \/ __ \ | /| / / ___/ __/
/ /_/ / /_/ / __/ / / / | / | / / / / /_
\_ ___/ .___/\_ __/_/ /_/| __/| __/_/ \_ _/
/_/ W I R E L E S S F R E E D O M
2023-05-22 12:54:10 +02:00
EOF
}
header_info
echo -e "Loading..."
2023-05-23 13:36:27 +02:00
GEN_MAC = 02:$( openssl rand -hex 5 | awk '{print toupper($0)}' | sed 's/\(..\)/\1:/g; s/.$//' )
GEN_MAC_LAN = 02:$( openssl rand -hex 5 | awk '{print toupper($0)}' | sed 's/\(..\)/\1:/g; s/.$//' )
2023-05-22 12:54:10 +02:00
NEXTID = $( pvesh get /cluster/nextid)
YW = $( echo "\033[33m" )
BL = $( echo "\033[36m" )
HA = $( echo "\033[1;34m" )
RD = $( echo "\033[01;31m" )
BGN = $( echo "\033[4;92m" )
GN = $( echo "\033[1;92m" )
DGN = $( echo "\033[32m" )
CL = $( echo "\033[m" )
BFR = "\\r\\033[K"
HOLD = "-"
CM = " ${ GN } ✓ ${ CL } "
2023-05-23 13:36:27 +02:00
CROSS = " ${ RD } ✗ ${ CL } "
2023-09-26 17:43:20 +02:00
set -Eeo pipefail
2023-05-23 13:36:27 +02:00
trap 'error_handler $LINENO "$BASH_COMMAND"' ERR
2023-05-22 12:54:10 +02:00
trap cleanup EXIT
2023-05-23 13:36:27 +02:00
function error_handler( ) {
local exit_code = " $? "
local line_number = " $1 "
local command = " $2 "
local error_message = " ${ RD } [ERROR] ${ CL } in line ${ RD } $line_number ${ CL } : exit code ${ RD } $exit_code ${ CL } : while executing command ${ YW } $command ${ CL } "
echo -e " \n $error_message \n "
cleanup_vmid
2023-05-22 12:54:10 +02:00
}
2023-05-23 13:36:27 +02:00
2023-05-22 12:54:10 +02:00
function cleanup_vmid( ) {
2023-05-23 13:36:27 +02:00
if qm status $VMID & >/dev/null; then
qm stop $VMID & >/dev/null
qm destroy $VMID & >/dev/null
2023-05-22 12:54:10 +02:00
fi
}
2023-05-23 13:36:27 +02:00
2023-05-22 12:54:10 +02:00
function cleanup( ) {
popd >/dev/null
rm -rf $TEMP_DIR
}
2023-05-23 13:36:27 +02:00
TEMP_DIR = $( mktemp -d)
pushd $TEMP_DIR >/dev/null
2023-05-22 12:54:10 +02:00
function send_line_to_vm( ) {
echo -e " ${ DGN } Sending line: ${ YW } $1 ${ CL } "
2023-05-22 13:40:19 +02:00
for ( ( i = 0; i < ${# 1 } ; i++) ) ; do
2023-05-22 12:54:10 +02:00
character = ${ 1 : i : 1 }
case $character in
2023-05-22 13:40:19 +02:00
" " ) character = "spc" ; ;
"-" ) character = "minus" ; ;
"=" ) character = "equal" ; ;
"," ) character = "comma" ; ;
"." ) character = "dot" ; ;
"/" ) character = "slash" ; ;
"'" ) character = "apostrophe" ; ;
";" ) character = "semicolon" ; ;
'\' ) character = "backslash" ; ;
'`' ) character = "grave_accent" ; ;
"[" ) character = "bracket_left" ; ;
"]" ) character = "bracket_right" ; ;
"_" ) character = "shift-minus" ; ;
"+" ) character = "shift-equal" ; ;
"?" ) character = "shift-slash" ; ;
"<" ) character = "shift-comma" ; ;
">" ) character = "shift-dot" ; ;
'"' ) character = "shift-apostrophe" ; ;
":" ) character = "shift-semicolon" ; ;
"|" ) character = "shift-backslash" ; ;
"~" ) character = "shift-grave_accent" ; ;
"{" ) character = "shift-bracket_left" ; ;
"}" ) character = "shift-bracket_right" ; ;
"A" ) character = "shift-a" ; ;
"B" ) character = "shift-b" ; ;
"C" ) character = "shift-c" ; ;
"D" ) character = "shift-d" ; ;
"E" ) character = "shift-e" ; ;
"F" ) character = "shift-f" ; ;
"G" ) character = "shift-g" ; ;
"H" ) character = "shift-h" ; ;
"I" ) character = "shift-i" ; ;
"J" ) character = "shift-j" ; ;
"K" ) character = "shift-k" ; ;
"L" ) character = "shift-l" ; ;
"M" ) character = "shift-m" ; ;
"N" ) character = "shift-n" ; ;
"O" ) character = "shift-o" ; ;
"P" ) character = "shift-p" ; ;
"Q" ) character = "shift-q" ; ;
"R" ) character = "shift-r" ; ;
"S" ) character = "shift-s" ; ;
"T" ) character = "shift-t" ; ;
"U" ) character = "shift-u" ; ;
"V" ) character = "shift-v" ; ;
"W" ) character = "shift-w" ; ;
"X" ) character = "shift=x" ; ;
"Y" ) character = "shift-y" ; ;
"Z" ) character = "shift-z" ; ;
"!" ) character = "shift-1" ; ;
"@" ) character = "shift-2" ; ;
"#" ) character = "shift-3" ; ;
'$' ) character = "shift-4" ; ;
"%" ) character = "shift-5" ; ;
"^" ) character = "shift-6" ; ;
"&" ) character = "shift-7" ; ;
"*" ) character = "shift-8" ; ;
"(" ) character = "shift-9" ; ;
")" ) character = "shift-0" ; ;
2023-05-22 12:54:10 +02:00
esac
qm sendkey $VMID " $character "
done
qm sendkey $VMID ret
}
TEMP_DIR = $( mktemp -d)
pushd $TEMP_DIR >/dev/null
2023-05-23 13:36:27 +02:00
2023-09-09 11:13:17 +02:00
if ( whiptail --backtitle "Proxmox VE Helper Scripts" --title "OpenWrt VM" --yesno "This will create a New OpenWrt VM. Proceed?" 10 58) ; then
2023-05-23 13:36:27 +02:00
:
2023-05-22 12:54:10 +02:00
else
2023-05-23 13:36:27 +02:00
header_info && echo -e "⚠ User exited script \n" && exit
2023-05-22 12:54:10 +02:00
fi
function msg_info( ) {
local msg = " $1 "
echo -ne " ${ HOLD } ${ YW } ${ msg } ... "
}
2023-05-23 13:36:27 +02:00
2023-05-22 12:54:10 +02:00
function msg_ok( ) {
local msg = " $1 "
echo -e " ${ BFR } ${ CM } ${ GN } ${ msg } ${ CL } "
}
2023-05-23 13:36:27 +02:00
function msg_error( ) {
local msg = " $1 "
echo -e " ${ BFR } ${ CROSS } ${ RD } ${ msg } ${ CL } "
}
function pve_check( ) {
2023-06-22 21:55:39 +02:00
if ! pveversion | grep -Eq "pve-manager/(7\.[2-9]|8\.[0-9])" ; then
2023-05-23 13:36:27 +02:00
echo -e " ${ CROSS } This version of Proxmox Virtual Environment is not supported "
echo -e "Requires PVE Version 7.2 or higher"
echo -e "Exiting..."
sleep 2
exit
fi
}
function arch_check( ) {
if [ " $( dpkg --print-architecture) " != "amd64" ] ; then
echo -e " \n ${ CROSS } This script will not work with PiMox! \n "
echo -e "Exiting..."
sleep 2
exit
fi
}
function ssh_check( ) {
if command -v pveversion >/dev/null 2>& 1; then
if [ -n " ${ SSH_CLIENT : +x } " ] ; then
2023-09-09 11:13:17 +02:00
if whiptail --backtitle "Proxmox VE Helper Scripts" --defaultno --title "SSH DETECTED" --yesno "It's suggested to use the Proxmox shell instead of SSH, since SSH can create issues while gathering variables. Would you like to proceed with using SSH?" 10 62; then
2023-05-23 13:36:27 +02:00
echo "you've been warned"
else
clear
exit
fi
fi
fi
}
function exit-script( ) {
clear
echo -e "⚠ User exited script \n"
exit
}
2023-05-22 12:54:10 +02:00
function default_settings( ) {
VMID = $NEXTID
HN = openwrt
CORE_COUNT = "1"
RAM_SIZE = "256"
BRG = "vmbr0"
VLAN = ""
MAC = $GEN_MAC
LAN_MAC = $GEN_MAC_LAN
LAN_BRG = "vmbr0"
2023-07-11 12:16:46 +02:00
LAN_IP_ADDR = "192.168.1.1"
LAN_NETMASK = "255.255.255.0"
2023-05-22 12:54:10 +02:00
LAN_VLAN = ",tag=999"
MTU = ""
START_VM = "yes"
2023-05-23 13:36:27 +02:00
echo -e " ${ DGN } Using Virtual Machine ID: ${ BGN } ${ VMID } ${ CL } "
echo -e " ${ DGN } Using Hostname: ${ BGN } ${ HN } ${ CL } "
echo -e " ${ DGN } Allocated Cores: ${ BGN } ${ CORE_COUNT } ${ CL } "
echo -e " ${ DGN } Allocated RAM: ${ BGN } ${ RAM_SIZE } ${ CL } "
echo -e " ${ DGN } Using WAN Bridge: ${ BGN } ${ BRG } ${ CL } "
echo -e " ${ DGN } Using WAN VLAN: ${ BGN } Default ${ CL } "
echo -e " ${ DGN } Using WAN MAC Address: ${ BGN } ${ MAC } ${ CL } "
echo -e " ${ DGN } Using LAN MAC Address: ${ BGN } ${ LAN_MAC } ${ CL } "
echo -e " ${ DGN } Using LAN Bridge: ${ BGN } ${ LAN_BRG } ${ CL } "
echo -e " ${ DGN } Using LAN VLAN: ${ BGN } 999 ${ CL } "
2023-07-11 12:16:46 +02:00
echo -e " ${ DGN } Using LAN IP Address: ${ BGN } ${ LAN_IP_ADDR } ${ CL } "
echo -e " ${ DGN } Using LAN NETMASK: ${ BGN } ${ LAN_NETMASK } ${ CL } "
2023-05-23 13:36:27 +02:00
echo -e " ${ DGN } Using Interface MTU Size: ${ BGN } Default ${ CL } "
echo -e " ${ DGN } Start VM when completed: ${ BGN } yes ${ CL } "
2023-05-22 12:54:10 +02:00
echo -e " ${ BL } Creating a OpenWRT VM using the above default settings ${ CL } "
}
2023-05-23 13:36:27 +02:00
2023-05-22 12:54:10 +02:00
function advanced_settings( ) {
2023-05-23 13:36:27 +02:00
while true; do
2023-09-09 11:13:17 +02:00
if VMID = $( whiptail --backtitle "Proxmox VE Helper Scripts" --inputbox "Set Virtual Machine ID" 8 58 $NEXTID --title "VIRTUAL MACHINE ID" --cancel-button Exit-Script 3>& 1 1>& 2 2>& 3) ; then
2023-05-23 13:36:27 +02:00
if [ -z " $VMID " ] ; then
VMID = " $NEXTID "
fi
if pct status " $VMID " & >/dev/null || qm status " $VMID " & >/dev/null; then
echo -e " ${ CROSS } ${ RD } ID $VMID is already in use ${ CL } "
sleep 2
continue
fi
echo -e " ${ DGN } Virtual Machine ID: ${ BGN } $VMID ${ CL } "
break
else
exit-script
fi
done
2023-09-09 11:13:17 +02:00
if VM_NAME = $( whiptail --backtitle "Proxmox VE Helper Scripts" --inputbox "Set Hostname" 8 58 openwrt --title "HOSTNAME" --cancel-button Exit-Script 3>& 1 1>& 2 2>& 3) ; then
2023-05-23 13:36:27 +02:00
if [ -z $VM_NAME ] ; then
HN = "openwrt"
else
HN = $( echo ${ VM_NAME ,, } | tr -d ' ' )
fi
2023-06-03 17:29:30 +02:00
echo -e " ${ DGN } Using Hostname: ${ BGN } $HN ${ CL } "
2023-05-22 12:54:10 +02:00
else
2023-05-23 13:36:27 +02:00
exit-script
2023-05-22 12:54:10 +02:00
fi
2023-05-23 13:36:27 +02:00
2023-09-09 11:13:17 +02:00
if CORE_COUNT = $( whiptail --backtitle "Proxmox VE Helper Scripts" --inputbox "Allocate CPU Cores" 8 58 1 --title "CORE COUNT" --cancel-button Exit-Script 3>& 1 1>& 2 2>& 3) ; then
2023-05-23 13:36:27 +02:00
if [ -z $CORE_COUNT ] ; then
CORE_COUNT = "1"
fi
2023-06-03 17:29:30 +02:00
echo -e " ${ DGN } Allocated Cores: ${ BGN } $CORE_COUNT ${ CL } "
2023-05-22 12:54:10 +02:00
else
2023-05-23 13:36:27 +02:00
exit-script
2023-05-22 12:54:10 +02:00
fi
2023-05-23 13:36:27 +02:00
2023-09-09 11:13:17 +02:00
if RAM_SIZE = $( whiptail --backtitle "Proxmox VE Helper Scripts" --inputbox "Allocate RAM in MiB" 8 58 256 --title "RAM" --cancel-button Exit-Script 3>& 1 1>& 2 2>& 3) ; then
2023-05-23 13:36:27 +02:00
if [ -z $RAM_SIZE ] ; then
RAM_SIZE = "256"
fi
2023-06-03 17:29:30 +02:00
echo -e " ${ DGN } Allocated RAM: ${ BGN } $RAM_SIZE ${ CL } "
2023-05-22 12:54:10 +02:00
else
2023-05-23 13:36:27 +02:00
exit-script
2023-05-22 12:54:10 +02:00
fi
2023-05-23 13:36:27 +02:00
2023-09-09 11:13:17 +02:00
if BRG = $( whiptail --backtitle "Proxmox VE Helper Scripts" --inputbox "Set a WAN Bridge" 8 58 vmbr0 --title "WAN BRIDGE" --cancel-button Exit-Script 3>& 1 1>& 2 2>& 3) ; then
2023-05-23 13:36:27 +02:00
if [ -z $BRG ] ; then
BRG = "vmbr0"
fi
2023-06-03 17:29:30 +02:00
echo -e " ${ DGN } Using WAN Bridge: ${ BGN } $BRG ${ CL } "
2023-05-22 12:54:10 +02:00
else
2023-05-23 13:36:27 +02:00
exit-script
2023-05-22 12:54:10 +02:00
fi
2023-05-23 13:36:27 +02:00
2023-09-09 11:13:17 +02:00
if LAN_BRG = $( whiptail --backtitle "Proxmox VE Helper Scripts" --inputbox "Set a LAN Bridge" 8 58 vmbr0 --title "LAN BRIDGE" --cancel-button Exit-Script 3>& 1 1>& 2 2>& 3) ; then
2023-05-23 13:36:27 +02:00
if [ -z $LAN_BRG ] ; then
LAN_BRG = "vmbr0"
fi
2023-06-03 17:29:30 +02:00
echo -e " ${ DGN } Using LAN Bridge: ${ BGN } $LAN_BRG ${ CL } "
2023-05-22 12:54:10 +02:00
else
2023-05-23 13:36:27 +02:00
exit-script
2023-05-22 12:54:10 +02:00
fi
2023-05-23 13:36:27 +02:00
2023-09-09 11:13:17 +02:00
if LAN_IP_ADDR = $( whiptail --backtitle "Proxmox VE Helper Scripts" --inputbox "Set a router IP" 8 58 $LAN_IP_ADDR --title "LAN IP ADDRESS" --cancel-button Exit-Script 3>& 1 1>& 2 2>& 3) ; then
2023-07-11 12:16:46 +02:00
if [ -z $LAN_IP_ADDR ] ; then
LAN_IP_ADDR = "192.168.1.1"
fi
echo -e " ${ DGN } Using LAN IP ADDRESS: ${ BGN } $LAN_IP_ADDR ${ CL } "
else
exit-script
fi
2023-09-09 11:13:17 +02:00
if LAN_NETMASK = $( whiptail --backtitle "Proxmox VE Helper Scripts" --inputbox "Set a router netmmask" 8 58 $LAN_NETMASK --title "LAN NETMASK" --cancel-button Exit-Script 3>& 1 1>& 2 2>& 3) ; then
2023-07-11 12:16:46 +02:00
if [ -z $LAN_NETMASK ] ; then
LAN_NETMASK = "255.255.255.0"
fi
echo -e " ${ DGN } Using LAN NETMASK: ${ BGN } $LAN_NETMASK ${ CL } "
else
exit-script
fi
2023-09-09 11:13:17 +02:00
if MAC1 = $( whiptail --backtitle "Proxmox VE Helper Scripts" --inputbox "Set a WAN MAC Address" 8 58 $GEN_MAC --title "WAN MAC ADDRESS" --cancel-button Exit-Script 3>& 1 1>& 2 2>& 3) ; then
2023-05-23 13:36:27 +02:00
if [ -z $MAC1 ] ; then
MAC = " $GEN_MAC "
else
MAC = " $MAC1 "
fi
2023-06-03 17:29:30 +02:00
echo -e " ${ DGN } Using WAN MAC Address: ${ BGN } $MAC ${ CL } "
2023-05-22 12:54:10 +02:00
else
2023-05-23 13:36:27 +02:00
exit-script
2023-05-22 12:54:10 +02:00
fi
2023-05-23 13:36:27 +02:00
2023-09-09 11:13:17 +02:00
if MAC2 = $( whiptail --backtitle "Proxmox VE Helper Scripts" --inputbox "Set a LAN MAC Address" 8 58 $GEN_MAC_LAN --title "LAN MAC ADDRESS" --cancel-button Exit-Script 3>& 1 1>& 2 2>& 3) ; then
2023-05-23 13:36:27 +02:00
if [ -z $MAC2 ] ; then
LAN_MAC = " $GEN_MAC_LAN "
else
LAN_MAC = " $MAC2 "
fi
2023-06-03 17:29:30 +02:00
echo -e " ${ DGN } Using LAN MAC Address: ${ BGN } $LAN_MAC ${ CL } "
2023-05-22 12:54:10 +02:00
else
2023-05-23 13:36:27 +02:00
exit-script
2023-05-22 12:54:10 +02:00
fi
2023-05-23 13:36:27 +02:00
2023-09-09 11:13:17 +02:00
if VLAN1 = $( whiptail --backtitle "Proxmox VE Helper Scripts" --inputbox "Set a WAN Vlan (leave blank for default)" 8 58 --title "WAN VLAN" --cancel-button Exit-Script 3>& 1 1>& 2 2>& 3) ; then
2023-05-22 12:54:10 +02:00
if [ -z $VLAN1 ] ; then
2023-05-23 13:36:27 +02:00
VLAN1 = "Default"
VLAN = ""
2023-05-22 12:54:10 +02:00
else
VLAN = " ,tag= $VLAN1 "
fi
2023-06-03 17:29:30 +02:00
echo -e " ${ DGN } Using WAN Vlan: ${ BGN } $VLAN1 ${ CL } "
2023-05-23 13:36:27 +02:00
else
exit-script
2023-05-22 12:54:10 +02:00
fi
2023-05-23 13:36:27 +02:00
2023-09-09 11:13:17 +02:00
if VLAN2 = $( whiptail --backtitle "Proxmox VE Helper Scripts" --inputbox "Set a LAN Vlan" 8 58 999 --title "LAN VLAN" --cancel-button Exit-Script 3>& 1 1>& 2 2>& 3) ; then
2023-05-22 12:54:10 +02:00
if [ -z $VLAN2 ] ; then
2023-05-23 13:36:27 +02:00
VLAN2 = "999"
LAN_VLAN = " ,tag= $VLAN2 "
2023-05-22 12:54:10 +02:00
else
LAN_VLAN = " ,tag= $VLAN2 "
fi
2023-06-03 17:29:30 +02:00
echo -e " ${ DGN } Using LAN Vlan: ${ BGN } $VLAN2 ${ CL } "
2023-05-23 13:36:27 +02:00
else
exit-script
2023-05-22 12:54:10 +02:00
fi
2023-05-23 13:36:27 +02:00
2023-09-09 11:13:17 +02:00
if MTU1 = $( whiptail --backtitle "Proxmox VE Helper Scripts" --inputbox "Set Interface MTU Size (leave blank for default)" 8 58 --title "MTU SIZE" --cancel-button Exit-Script 3>& 1 1>& 2 2>& 3) ; then
2023-05-22 12:54:10 +02:00
if [ -z $MTU1 ] ; then
2023-05-23 13:36:27 +02:00
MTU1 = "Default"
MTU = ""
2023-05-22 12:54:10 +02:00
else
MTU = " ,mtu= $MTU1 "
fi
2023-06-03 17:29:30 +02:00
echo -e " ${ DGN } Using Interface MTU Size: ${ BGN } $MTU1 ${ CL } "
2023-05-23 13:36:27 +02:00
else
exit-script
2023-05-22 12:54:10 +02:00
fi
2023-05-23 13:36:27 +02:00
2023-09-09 11:13:17 +02:00
if ( whiptail --backtitle "Proxmox VE Helper Scripts" --title "START VIRTUAL MACHINE" --yesno "Start VM when completed?" 10 58) ; then
2023-05-22 12:54:10 +02:00
START_VM = "yes"
else
START_VM = "no"
fi
2023-06-03 17:29:30 +02:00
echo -e " ${ DGN } Start VM when completed: ${ BGN } $START_VM ${ CL } "
2023-05-23 13:36:27 +02:00
2023-09-09 11:13:17 +02:00
if ( whiptail --backtitle "Proxmox VE Helper Scripts" --title "ADVANCED SETTINGS COMPLETE" --yesno "Ready to create OpenWrt VM?" --no-button Do-Over 10 58) ; then
2023-05-23 13:36:27 +02:00
echo -e " ${ RD } Creating a OpenWrt VM using the above advanced settings ${ CL } "
2023-05-22 12:54:10 +02:00
else
header_info
echo -e " ${ RD } Using Advanced Settings ${ CL } "
advanced_settings
fi
}
2023-05-23 13:36:27 +02:00
2023-05-22 12:54:10 +02:00
function start_script( ) {
2023-09-09 11:13:17 +02:00
if ( whiptail --backtitle "Proxmox VE Helper Scripts" --title "SETTINGS" --yesno "Use Default Settings?" --no-button Advanced 10 58) ; then
2023-05-22 12:54:10 +02:00
header_info
echo -e " ${ BL } Using Default Settings ${ CL } "
default_settings
else
header_info
echo -e " ${ RD } Using Advanced Settings ${ CL } "
advanced_settings
fi
}
2023-05-23 13:36:27 +02:00
arch_check
pve_check
ssh_check
2023-05-22 12:54:10 +02:00
start_script
2023-05-23 13:36:27 +02:00
2023-05-22 12:54:10 +02:00
msg_info "Validating Storage"
while read -r line; do
TAG = $( echo $line | awk '{print $1}' )
TYPE = $( echo $line | awk '{printf "%-10s", $2}' )
FREE = $( echo $line | numfmt --field 4-6 --from-unit= K --to= iec --format %.2f | awk '{printf( "%9sB", $6)}' )
ITEM = " Type: $TYPE Free: $FREE "
OFFSET = 2
if [ [ $(( ${# ITEM } + $OFFSET )) -gt ${ MSG_MAX_LENGTH :- } ] ] ; then
MSG_MAX_LENGTH = $(( ${# ITEM } + $OFFSET ))
fi
STORAGE_MENU += ( " $TAG " " $ITEM " "OFF" )
done < <( pvesm status -content images | awk 'NR>1' )
VALID = $( pvesm status -content images | awk 'NR>1' )
if [ -z " $VALID " ] ; then
echo -e " \n ${ RD } ⚠ Unable to detect a valid storage location. ${ CL } "
echo -e "Exiting..."
exit
elif [ $(( ${# STORAGE_MENU [@] } / 3 )) -eq 1 ] ; then
STORAGE = ${ STORAGE_MENU [0] }
else
while [ -z " ${ STORAGE : +x } " ] ; do
2023-09-09 11:13:17 +02:00
STORAGE = $( whiptail --backtitle "Proxmox VE Helper Scripts" --title "Storage Pools" --radiolist \
2023-05-23 13:36:27 +02:00
"Which storage pool you would like to use for the OpenWrt VM?\n\n" \
2023-05-22 12:54:10 +02:00
16 $(( $MSG_MAX_LENGTH + 23 )) 6 \
" ${ STORAGE_MENU [@] } " 3>& 1 1>& 2 2>& 3) || exit
done
fi
msg_ok " Using ${ CL } ${ BL } $STORAGE ${ CL } ${ GN } for Storage Location. "
msg_ok " Virtual Machine ID is ${ CL } ${ BL } $VMID ${ CL } . "
2023-05-23 13:36:27 +02:00
msg_info "Getting URL for OpenWrt Disk Image"
2023-05-22 12:54:10 +02:00
regex = '<strong>Current Stable Release - OpenWrt ([^/]*)<\/strong>' && response = $( curl -s https://openwrt.org) && [ [ $response = ~ $regex ] ] && stableVersion = " ${ BASH_REMATCH [1] } "
URL = https://downloads.openwrt.org/releases/$stableVersion /targets/x86/64/openwrt-$stableVersion -x86-64-generic-ext4-combined.img.gz
sleep 2
msg_ok " ${ CL } ${ BL } ${ URL } ${ CL } "
wget -q --show-progress $URL
echo -en "\e[1A\e[0K"
FILE = $( basename $URL )
msg_ok " Downloaded ${ CL } ${ BL } $FILE ${ CL } "
gunzip -f $FILE >/dev/null 2>/dev/null || true
NEWFILE = " ${ FILE %.* } "
FILE = " $NEWFILE "
mv $FILE ${ FILE %.* }
qemu-img resize -f raw ${ FILE %.* } 512M >/dev/null 2>/dev/null
2023-05-23 13:36:27 +02:00
msg_ok " Extracted & Resized OpenWrt Disk Image ${ CL } ${ BL } $FILE ${ CL } "
2023-05-22 12:54:10 +02:00
STORAGE_TYPE = $( pvesm status -storage $STORAGE | awk 'NR>1 {print $2}' )
case $STORAGE_TYPE in
nfs | dir)
DISK_EXT = ".qcow2"
DISK_REF = " $VMID / "
DISK_IMPORT = "-format qcow2"
; ;
btrfs)
DISK_EXT = ".raw"
DISK_REF = " $VMID / "
DISK_IMPORT = "-format raw"
; ;
esac
for i in { 0,1} ; do
disk = " DISK $i "
eval DISK${ i } = vm-${ VMID } -disk-${ i } ${ DISK_EXT :- }
eval DISK${ i } _REF = ${ STORAGE } :${ DISK_REF :- } ${ !disk }
done
2023-05-23 13:36:27 +02:00
msg_info "Creating OpenWrt VM"
2023-05-22 12:54:10 +02:00
qm create $VMID -cores $CORE_COUNT -memory $RAM_SIZE -name $HN \
-onboot 1 -ostype l26 -scsihw virtio-scsi-pci --tablet 0
pvesm alloc $STORAGE $VMID $DISK0 4M 1>& /dev/null
qm importdisk $VMID ${ FILE %.* } $STORAGE ${ DISK_IMPORT :- } 1>& /dev/null
qm set $VMID \
2023-05-23 13:36:27 +02:00
-efidisk0 ${ DISK0_REF } ,efitype= 4m,size= 4M \
2023-05-22 12:54:10 +02:00
-scsi0 ${ DISK1_REF } ,size= 512M \
-boot order = scsi0 \
2023-05-23 13:36:27 +02:00
-description " # OpenWrt VM
2023-05-22 12:54:10 +02:00
### https://github.com/tteck/Proxmox
[ ![ ko-fi] ( https://ko-fi.com/img/githubbutton_sm.svg) ] ( https://ko-fi.com/D1D7EP4GF) " >/dev/null
2023-05-23 13:36:27 +02:00
msg_ok " OpenWrt VM ${ CL } ${ BL } ( ${ HN } ) "
msg_info "OpenWrt is being started in order to configure the network interfaces."
2023-05-22 12:54:10 +02:00
qm start $VMID
sleep 15
2023-05-23 13:36:27 +02:00
msg_ok "Network interfaces are being configured as OpenWrt initiates."
2023-05-22 12:54:10 +02:00
send_line_to_vm ""
send_line_to_vm "uci delete network.@device[0]"
send_line_to_vm "uci set network.wan=interface"
2023-06-03 17:29:30 +02:00
send_line_to_vm "uci set network.wan.device=eth1"
2023-05-22 12:54:10 +02:00
send_line_to_vm "uci set network.wan.proto=dhcp"
send_line_to_vm "uci delete network.lan"
send_line_to_vm "uci set network.lan=interface"
2023-06-03 17:29:30 +02:00
send_line_to_vm "uci set network.lan.device=eth0"
2023-05-22 12:54:10 +02:00
send_line_to_vm "uci set network.lan.proto=static"
2023-07-11 12:16:46 +02:00
send_line_to_vm " uci set network.lan.ipaddr= ${ LAN_IP_ADDR } "
send_line_to_vm " uci set network.lan.netmask= ${ LAN_NETMASK } "
2023-05-22 12:54:10 +02:00
send_line_to_vm "uci set firewall.@zone[1].input='ACCEPT'"
send_line_to_vm "uci set firewall.@zone[1].forward='ACCEPT'"
send_line_to_vm "uci commit"
send_line_to_vm "halt"
2023-05-23 13:36:27 +02:00
msg_ok "Network interfaces have been successfully configured."
2023-05-22 13:40:19 +02:00
until qm status $VMID | grep -q "stopped" ; do
2023-05-22 12:54:10 +02:00
sleep 2
done
2023-05-23 13:36:27 +02:00
msg_info "Bridge interfaces are being added."
2023-05-22 12:54:10 +02:00
qm set $VMID \
2023-06-03 17:29:30 +02:00
-net0 virtio,bridge= ${ LAN_BRG } ,macaddr= ${ LAN_MAC } ${ LAN_VLAN } ${ MTU } \
-net1 virtio,bridge= ${ BRG } ,macaddr= ${ MAC } ${ VLAN } ${ MTU } >/dev/null 2>/dev/null
2023-05-23 13:36:27 +02:00
msg_ok "Bridge interfaces have been successfully added."
2023-05-22 12:54:10 +02:00
if [ " $START_VM " = = "yes" ] ; then
2023-05-23 13:36:27 +02:00
msg_info "Starting OpenWrt VM"
2023-05-22 12:54:10 +02:00
qm start $VMID
2023-05-23 13:36:27 +02:00
msg_ok "Started OpenWrt VM"
2023-05-22 12:54:10 +02:00
fi
VLAN_FINISH = ""
2023-05-23 13:36:27 +02:00
if [ " $VLAN " = = "" ] && [ " $VLAN2 " != "999" ] ; then
2023-05-22 12:54:10 +02:00
VLAN_FINISH = " Please remember to adjust the VLAN tags to suit your network."
fi
2023-05-23 13:36:27 +02:00
msg_ok " Completed Successfully!\n ${ VLAN_FINISH } "